<%
'/** 
' * ڿ  class
' * 
' * @filename  : sky_string_class.asp
' * @version   : v 1.0 2003.07.29 10:59:35
' * @author    : nsl (smpoem@magicn.com)
' * @copyright : Copyright  2003 nsl All rights reserved.
' */


class SkyString


    '  üũ ⺻Լ 
    ' isNumeric()

    '/**
    ' *  ˻ (a-zA-Z)
    ' *
    ' * @param string str : ڿ
    ' *
    ' * @return boolean
    ' */
    function isString(byval str)

        dim regex, match, matches

        set regex = new regexp

        ' ^   a-zA-Z   ڸ ã´
        regex.pattern = "[^a-zA-Z]"

        regex.IgnoreCase = false   ' false(ҹڱ), true(о, ⺻)
        regex.global     = true    ' true(üڿ), false(ó͸, ⺻)

        '   ڰ ִٸ
        if regex.test(str) then
            isString = false 
        else
            isString = true
        end if

    end function

    '/**
    ' * ڿ OR   ˻ (a-zA-Z0-9)
    ' *
    ' * @param string str : ڿ
    ' *
    ' * @return boolean
    ' */
    function isStringNumeric(byval str)

        dim regex, match, matches

        set regex = new regexp

        ' ^   a-zA-Z0-9   ڸ ã´
        regex.pattern = "[^a-zA-Z0-9]"

        regex.IgnoreCase = false   ' false(ҹڱ), true(о, ⺻)
        regex.global     = true    ' true(üڿ), false(ó͸, ⺻)

        '   ڰ ִٸ
        if regex.test(str) then
            isStringNumeric = false 
        else
            isStringNumeric = true
        end if

    end function
    
    '/**
    ' * ڿ Ͽ ´ ˻
    ' *
    ' * @param string str : ˻ ڿ
    ' * @param string pattern : Խ 
    ' *
    ' * @return boolean
    ' * @example
    ' *   - ҹ ˻ : [^a-z]
    ' *   - 빮 ˻ : [^A-Z]
    ' */
    function isPatternCheck(byval str, byval pattern)

        dim regex, match, matches

        set regex = new regexp

        ' ^   a-zA-Z   ڸ ã´
        regex.pattern = pattern

        regex.IgnoreCase = false   ' false(ҹڱ), true(о, ⺻)
        regex.global     = true    ' true(üڿ), false(ó͸, ⺻)

        '   ڰ ִٸ
        if regex.test(str) then
            isPatternCheck = false 
        else
            isPatternCheck = true
        end if

    end function

    '/**
    '* ڿ ̸ Ѵ (2Ʈ ڴ 2byte )
    '* len()  Լ 繮ڸ  1byte  Ѵ
    '*
    '* @param  string  str  : ڿ
    '*/
    function strlen(str)

        dim slength, sTemp, i

        slength = 0

        for i = 1 to len(str)

            sTemp = cint( asc( mid(str, i, 1) ) )

            '// 2Ʈ̸ +2
            if sTemp < 0 OR sTemp >= 128  then
                slength = slength + 2
            else
                slength = slength + 1
            end if

        next

        strlen = slength

    end function

    '/**
	'* ڿ ϴ ̷ ߶ش
	'*
	'* @param  string  str    : ڸ ڿ
	'* @param  integer maxLen :  ũ
	'* @param  string  mark   : ڸ  ޺κ ó 
    '*
    '* @info
    '*    : , 0.5 ~ 1.5 
	'*/
    function substr(str, maxLen, mark)

        dim slength, llength, sTemp, i, clength, clengthTemp

        clength = 0     '//  ڸ  Count
        clengthTemp = 0 '//  ڸ  count

        '// ڿ 
        slength = strlen(str) '//   ( 1byte )
        llength = len(str)    '// 

        '// 
		if (slength = (maxLen + 1)) then

	        slength = strlen(str & " ")
        end if


        '//  ڿ >   -> ڸ 
        if ( slength > maxLen ) then
   
            for i = 1 to llength

		        '//      >=  
       	        if ( clengthTemp >= maxLen ) then

                   exit for
                end if

                sTemp = cint( asc( mid(str, i, 1) ) )

                '// 2Ʈ̸ 0.5
                if sTemp < 0 OR sTemp >= 128 then

                    clength = clength + 0.5
                    clengthTemp = clengthTemp + 1
                else
                    clength = clength + 1
                    clengthTemp = clengthTemp + 1
                end if

           next
          
           substr = mid(str, 1, clength) & mark
       else

           substr = str
       end if

    end function

end class

   
%>